function[NeighbourM,NeighbourCM,NeighbourICon,ResistanceM]=zMakeNeighbourMatrix(N, Links, Resistance)

if nargin<3
    Resistance=zeros(length(Links),1);
end

NeighbourM=zeros(N);       % Neighbour Matrix,
NeighbourCM=zeros(N);      % The index of the node to its Neighbour
NeighbourICon=zeros(N,1);  % The Connectivity of Each Node.
ResistanceM=zeros(N);      % Resistance Matrix

NumberMatrix=zeros(N);
for i=1:N
    NumberMatrix(:,i)=i;
end

for i=1:length(Links)
    
    a=Links(1,i);
    b=Links(2,i);
    c=NeighbourICon(a);
    d=NeighbourICon(b);
    NeighbourM(a,c+1)=b;
    NeighbourM(b,d+1)=a;
    NeighbourCM(a,c+1)=NumberMatrix(b,d+1);
    NeighbourCM(b,d+1)=NumberMatrix(a,c+1);
    ResistanceM(a,c+1)=Resistance(i);
    ResistanceM(b,d+1)=Resistance(i);

    for j=1:N
        if (sum(NeighbourM(j,:))==0)
            NeighbourICon(j)=0;
        else
            e=NeighbourM(j,:);
            for k=N:-1:1
                if e(k)==0
                    e(k)=[];
                end
            end
            NeighbourICon(j)=length(e);
        end
    end
    
end

end